class MapNotSquareException(Exception):
    pass

class  PieceNotSquareException(Exception):
    pass

class save_Parser:
    def __init__(self, filename:str ):
        self.filename = filename
        self.map_shape = [[0]]
        self.pieces = list()

    def define_map(self, map_shape):
        size = len(map_shape)
        for row in map_shape:
            if size != len(row):
                raise MapNotSquareException
        self.map_shape = map_shape

    def add_piece(self, piece_shape):
        size = len(piece_shape)
        for row in piece_shape:
            if size != len(row):
                raise PieceNotSquareException
        self.pieces.append(piece_shape)

    def __str__(self):
        return str(self.map_shape)

    def shape_to_bytes(self, shape_matrix):
        shape_list = [b for r in shape_matrix for b in r]
        byte_ammount = len(shape_list) // 8 + 1
        tray = 0
        for i in shape_list:
            tray = (tray << 1) | i
        return tray.to_bytes(byte_ammount, 'big')


    def load(self):
        """
        load the file and prepare to parse informations
        """

    def save(self):
        """
        save parsed info to the file
        """
        save_data = b''
        save_data += b'SMS'
        save_data += len(self.map_shape).to_bytes(1, 'big')
        save_data += self.shape_to_bytes(self.map_shape)
        save_data += len(self.pieces).to_bytes(1, 'big')
        for piece in self.pieces:
            save_data +=len(piece).to_bytes(1, 'big')
            save_data += self.shape_to_bytes(piece)
        save_data += b'SME'
        with open(self.filename, mode='bw') as file:
            file.write(save_data)

if __name__ == "__main__":
    p = save_Parser('test.map')
    p.define_map([[1,0,1],[1,1,1], [1,0,0]])
    p.add_piece([[0, 1],[0, 1]])
    p.save()
    # print(p.shape_to_bytes([[1,0,1],[1,1,1], [1,0,0]]))
